gdcmconv(1)

NAME
gdcmconv - .TH "gdcmconv" 1 "Tue Feb 1 2011" "Version 2.0.17" "GDCM"

NAME
gdcmconv - .SH "SYNOPSIS"

gdcmconv [options] file-in file-out

DESCRIPTION

The gdcmconv command line program takes as input a DICOM file (file-in) and process it to generate an output DICOM file (file-out). The command line option dictate the type of operation(s) gdcmconv will use to generate the output file.

PARAMETERS

file-in   DICOM input filename
file-out  DICOM output filename

OPTIONS

  PARAMETERS

  -i --input      DICOM filename
  -o --output     DICOM filename

  OPTIONS

  -X --explicit            Change Transfer Syntax to explicit.
  -M --implicit            Change Transfer Syntax to implicit.
  -U --use-dict            Use dict for VR (only public by default).
     --with-private-dict   Use private dict for VR (advanced user only).
  -C --check-meta          Check File Meta Information (advanced user only).
     --root-uid            Root UID.
     --remove-gl           Remove group length (deprecated in DICOM 2008).
     --remove-private-tags Remove private tags.
     --remove-retired      Remove retired tags.

  image options

  -l --apply-lut                      Apply LUT (non-standard, advanced user only).
  -P --photometric-interpretation %s  Change Photometric Interpretation (when possible).
  -w --raw                            Decompress image.
  -d --deflated                       Compress using deflated (gzip).
  -J --jpeg                           Compress image in jpeg.
  -K --j2k                            Compress image in j2k.
  -L --jpegls                         Compress image in jpeg-ls.
  -R --rle                            Compress image in rle (lossless only).
  -F --force                          Force decompression/merging before recompression/splitting.
     --compress-icon                  Decide whether icon follows main TransferSyntax or remains uncompressed.
     --planar-configuration [01]      Change planar configuration.
  -Y --lossy                          Use the lossy (if possible) compressor.
  -S --split %d                       Write 2D image with multiple fragments (using max size)

  JPEG options

  -q --quality %*f           set quality.

  JPEG-LS options

  -e --lossy-error %*i       set error.

  J2K options

  -r --rate    %*f           set rate.
  -q --quality %*f           set quality.
  -t --tile %d,%d            set tile size.
  -n --number-resolution %d  set number of resolution.
     --irreversible          set irreversible.

  general options

  -h   --help
         print this help text and exit
  -v   --version
         print version information and exit
  -V   --verbose
         verbose mode (warning+error).
  -W   --warning
         warning mode, print warning information
  -E   --error
         error mode, print error information
  -D   --debug
         debug mode, print debug information

  special options

  -I --ignore-errors   convert even if file is corrupted (advanced users only, see disclaimers).

  environment variable

  GDCM_ROOT_UID Root UID

Simple usage

gdcmconv is a great tool to convert broken DICOM implementation into properly parsable DICOM file. Usage is simply:

gdcmconv input.dcm output.dcm

or if you prefer being explicit:

gdcmconv -i input.dcm -o output.dcm

Eventhough gdcmconv can overwrite directly on the same file (input.dcm = output.dcm), it is recommended that user should first convert into a different file to make sure the bug is properly handled by GDCM.

Typical cases where you would want to use gdcmconv in its simple form:

•   convert non-cp246 conforming file into conforming cp246,
•   convert implicit little endian transfer syntax file meta header into proper explicit little endian transfer syntax,
•   convert the GE-13 bytes bug,
•   convert dual syntax file: implicit/explicit,
•   convert Philips dual Little Endian/Big Endian file,
•   convert GDCM 1.2.0 broken UN-2-bytes fields,
•   &...
•   All other broken files listed in the supported section.
When no option other is used, only the dataset is inspected. So encapsulated Pixel Data, for instance, is not inspected for well known bugs.
When doing this kind of work, this is usually a good idea to perform some kind of quality control, see gdcmconv Quality Control section (down below).

Typical usage

  File Meta Header
Running
gdcmconv input.dcm output.dcm
Is not enough to recompute file meta header, when input file is buggy. You may want to use: --check-meta
$ gdcmconv --check-meta input.dcm output.dcm
See typical cases such as: GE_DLX-8-MONO2-PrivateSyntax.dcm or PICKER-16-MONO2-No_DicomV3_Preamble.dcm from gdcmData.

  Conversion to Explicit Transfer Syntax
To convert a file that was written using Implicit Transfer Syntax into Explicit Transfer Syntax simply use:
$ gdcmconv --explicit uncompressed.dcm compressed.dcm

  Compressing to lossless JPEG
To compress an uncompressed DICOM file to a JPEG Lossless encapsulated format:
$ gdcmconv --jpeg uncompressed.dcm compressed.dcm

  Compressing to lossy JPEG
To compress an uncompressed DICOM file to a JPEG Lossy encapsulated format:
$ gdcmconv --lossy --jpeg -q 90 uncompressed.dcm compressed.dcm
Note:
-q is just one of the many way to specify lossy quality, you need to inspect the other cmd line flag to specify lossyness properties.

  Compressing to lossless JPEG-LS
To compress an uncompressed DICOM file to a JPEG-LS Lossless encapsulated format:
$ gdcmconv --jpegls uncompressed.dcm compressed.dcm

  Compressing to lossy JPEG-LS
To compress an uncompressed DICOM file to a JPEG-LS Lossy encapsulated format:
$ gdcmconv --lossy --jpegls -e 2 uncompressed.dcm lossy_compressed.dcm
Note:
-e (or --lossy-error) means that the maximum tolerate error is 2 for each pixel value

  Compressing to lossless J2K
To compress an uncompressed DICOM file to a JPEG-2000 Lossless encapsulated format:
$ gdcmconv --j2k uncompressed.dcm compressed.dcm

  Compressing to lossy J2K
To compress an uncompressed DICOM file to a JPEG-2000 Lossy encapsulated format:
$ gdcmconv --lossy -q 55,50,45 --j2k uncompressed.dcm lossy_compressed.dcm
Note:
-q is just one of the many way to specify lossy quality, you need to inspect the other cmd line flag to specify lossyness properties.

  Compressing to lossless RLE
To compress an uncompressed DICOM file to a RLE Lossless encapsulated format:
$ gdcmconv --rle uncompressed.dcm compressed.dcm
There is no such thing as lossy RLE compression.

  Forcing (re)compression
Sometime it is necessary to use the --force option. By default when user specify --j2k and input file is already in JPEG 2000 encapsulated DICOM format then no operation takes places. By using --force you make sure that (re)compression operation takes places.
Real life example of why you would use --force:
•   When Pixel Data is missing data / is padded with junk
•   When you would like to make sure GDCM can handle decompression & recompression cycle

  Decompressing a Compressed DICOM
$ gdcmconv --raw compressed.dcm uncompressed.dcm

  Changing the planar Configuration
Often RLE files are compressed using a different Planar Comnfiguration (RRR ... GGG... BBB...) instead of the usual triplet (RGB ... RGB ... RGB ). So upon decompression the Planar Configuration is 1. This is perfectly legal in DICOM, however this is unconventional, and thus it may be a good idea to also change the planar configuration and set it to the default :
$ gdcmconv --raw --planar-configuration 0 compressed.dcm uncompressed1.dcm
To reinvert the planar configuration of file 'uncompressed1.dcm', simply do:
$ gdcmconv --raw --planar-configuration 1 uncompressed1.dcm uncompressed2.dcm

Lossless Conversion
When talking about lossless conversion, there is an ambiguity that need to be understood. To achieve higher compression ratio, the RGB color space is usually not used, in favor of a YBR one. Changing from one color space to the other is (bit level) not lossless.
For more detail, see what are the true lossless transformations as described:
http://sourceforge.net/apps/mediawiki/gdcm/index.php?title=Color_Space_Transformations

Quality Control
One important part when using gdcmconv it to have a way to quality control the output.
You can use 3rd party tool to check the output of gdcmconv is correct.

  DCMTK / dicom3tools
Using another DICOM implementation such as the one from DCMTK or dicom3tools can be a good process to check the output of gdcmconv.
•   For DCMTK use: dcmdump
•   For dicom3tools use: dcdump
For reference, gdcmconv --raw will act as dcmdjpeg +cn +px, since it never tries to convert color space.

  VIM: vimdiff
You can setup your favorite editor to compare the output, for instance in vim:
autocmd BufReadPre *.dcm set ro
autocmd BufReadPost *.dcm silent %!dcmdump -M +uc '%'
then simply do:
$ vimdiff input.dcm output.dcm

  vbindiff
On unix you can visually compare binary file using the vbindiff command:
$ vbindiff input.dcm output.dcm

SEE ALSO
gdcmdump(1), gdcmraw(1), gdcminfo(1)

COPYRIGHT
Copyright (c) 2006-2010 Mathieu Malaterre